<?php
// ADD-ON SETTINGS - INTEGRATED IN PVTCONTENT ONES


// COUPON FIELD - ADD CUSTOM ICON
function pcpp_coupon_details_field($field_id, $field, $value, $all_vals) {
	$icon 	= get_option('pcpp_coupon_field_icon');
	?>
    <tr class="pc_<?php echo $field_id ?>_tr">
		<td class="lcwp_sf_label">
        	<label>Premium Plan add-on - <?php _e("Coupon field's icon", 'pcma_ml') ?></label>
        </td>
		<td class="lcwp_sf_field">
			
            <div class="pc_field_icon_trigger">
            	<i class="fa <?php echo $icon ?>" title="set icon" style="display: inline-block;"></i>
                <input type="hidden" name="pcpp_coupon_field_icon" value="<?php echo $icon ?>" maxlength="40" /> 
            </div>
		</td>
	</tr>
    <?php
}
function pcpp_coupon_details($structure) {
	$structure['styling']['fix_field_details']['fields']['pcpp_coupon_field_icon'] = array(
		'type'		=> 'custom',
		'callback'	=> 'pcpp_coupon_details_field',
		'validation'=> array(
			array('index' => 'pcpp_coupon_field_icon', 'label' => "Premium Plans add-on - Coupon field's icon"),
		)
	);
	return $structure;
}
add_filter('pc_settings_structure', 'pcpp_coupon_details');




// STYLING OPTIONS FIELD CUSTOM ICON
function pcpp_styling_settings($structure) {
	include_once(PC_DIR . '/functions.php');
	
	// styling
	$to_edit = $structure['styling'];
	$to_add = array(
		'pcpp_styling' => array(
			'sect_name'	=> 'Premium Plans add-on - '. __("form fields", 'pcpp_ml'),
			'fields' 	=> array(
				
				'pcpp_plan_bg' => array(
					'label' => __("Plan box background - default state", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#fbfbfb',
					'note'	=> '',
				),
				'pcpp_plan_border_col' => array(
					'label' => __("Plan box border color - default state", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#e8e8e8',
					'note'	=> '',
				),
				'pcpp_plan_txt_col' => array(
					'label' => __("Plan box text color - default state", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#373737',
					'note'	=> '',
				),
				'pcpp_plan_flap_h' => array(
					'label' => __("Plan left flap color - hover state", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#ececec',
					'note'	=> '',
				),
				'spcr2' => array(
					'type' => 'spacer',
				),
				'pcpp_plan_bg_sel' => array(
					'label' => __("Plan box background - selected state", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#ffffff',
					'note'	=> '',
				),
				'pcpp_plan_txt_col_sel' => array(
					'label' => __("Plan box text color - selected state", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#373737',
					'note'	=> '',
				),
				'pcpp_plan_flap_sel' => array(
					'label' => __("Plan left flap color - selected state", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#d2d2d2',
					'note'	=> '',
				),
				'pcpp_onecol_divider' => array(
					'label' => __("Plans divider color - one-column layout", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#f1f1f1',
					'note'	=> '',
				),
				'spcr3' => array(
					'type' => 'spacer',
				),
				'pcpp_onecol_dd_arr_col' => array(
					'label' => __("Dropdown button - arrow color (one column layout)", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#444444',
					'note'	=> '',
				),
				'pcpp_onecol_dd_bord_col' => array(
					'label' => __("Dropdown button - border color (one column layout)", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#d3d3d3',
					'note'	=> '',
				),
				'spcr4' => array(
					'type' => 'spacer',
				),
				'pcpp_bold_fluid_layout' => array(
					'label' => __("Use bold layout in fluid forms?", 'pcpp_ml'),
					'type'	=> 'checkbox',
					'note'	=> __("If checked, bold layout will be applied in fluid registration and renewal forms", 'pcpp_ml'),
				),
				'pcpp_bfl_title_col' => array(
					'label' => __("Bold layout title color - default state", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#444444',
					'note'	=> '',
				),
				'pcpp_bfl_title_bg' => array(
					'label' => __("Bold layout title background - default state", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#eeeeee',
					'note'	=> '',
				),
				'spcr5' => array(
					'type' => 'spacer',
				),
				'pcpp_bfl_title_col_sel' => array(
					'label' => __("Bold layout title color - selected state", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#555555',
					'note'	=> '',
				),
				'pcpp_bfl_title_bg_sel' => array(
					'label' => __("Bold layout title background - selected state", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#dddddd',
					'note'	=> '',
				),
				'pcpp_bfl_border_col_sel' => array(
					'label' => __("Bold layout border color - selected state", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#f7f7f7',
					'note'	=> '',
				),
				'pcpp_bfl_title_bord_rad' => array(
					'label' 	=> __("Bold layout title - border radius", 'pcpp_ml'),
					'type'		=> 'slider',
					'min_val'	=> 0,
					'max_val'	=> 30,	
					'step'		=> 1,
					'value'		=> 'px',
					'def'		=> 3,
					'note'		=> '',
				),
				'spcr6' => array(
					'type' => 'spacer',
				),
				'pcpp_trial_bg' => array(
					'label' => __("Trial period box - background", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#f5f5f5',
					'note'	=> '',
				),
				'pcpp_trial_txt_col' => array(
					'label' => __("Trial period box - text color", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#373737',
					'note'	=> '',
				),
				'pcpp_trial_border_w' => array(
					'label' 	=> __("Trial period box - border width", 'pcpp_ml'),
					'type'		=> 'slider',
					'min_val'	=> 0,
					'max_val'	=> 6,	
					'step'		=> 1,
					'value'		=> 'px',
					'def'		=> 0,
					'note'		=> '',
				),
				'pcpp_trial_border_col' => array(
					'label' => __("Trial period box - border color", 'pcpp_ml'),
					'type'	=> 'color',
					'def'	=> '#d2d2d2',
					'note'	=> '',
				),
				'pcpp_trial_bord_rad' => array(
					'label' 	=> __("Trial period box - border radius", 'pcpp_ml'),
					'type'		=> 'slider',
					'min_val'	=> 0,
					'max_val'	=> 10,	
					'step'		=> 1,
					'value'		=> 'px',
					'def'		=> 1,
					'note'		=> '',
				),
			),
		),
	);
	
	$structure['styling'] = pc_inject_array_elem($to_add, $to_edit, 'colors');
	return $structure;	
}
add_filter('pc_settings_structure', 'pcpp_styling_settings');








// PCPP OPTIONS - ADD TAB
function pcpp_settings_tab($tabs) {
	$tabs['pcpp_setting'] = 'Premium Plans';
	return $tabs;
}
add_filter('pc_settings_tabs', 'pcpp_settings_tab');




// PCPP OPTIONS - CUSTOM FIELDS

// trial period
function pcpp_trial_preriod_field($field_id, $field, $value, $all_vals) {
	include_once(PCPP_DIR .'/functions.php');
	
	echo '	
	<tr class="pc_'. $field_id .'">
		<td class="lcwp_sf_label"><label>'. __('Trial period', 'pcpp_ml') .'</label></td>
		<td class="lcwp_sf_field">
			<input type="number" name="pcpp_trial_duration" value="'. (int)$all_vals['pcpp_trial_duration'] .'" autocomplete="off" maxlength="3" style="width: 60px; text-align: center;">
			<select name="pcpp_trial_type" autocomplete="off" style="width: 100px; position: relative; top: -2px;">';

				foreach(pcpp_periods() as $type => $name) {
					echo '<option value="'.$type.'" '.selected($all_vals['pcpp_trial_type'], $type).'>'. $name .'</option>';	
				}

	echo '
			</select>
		</td>
		<td><span class="lcwp_sf_note">'. __("Set a trial period for subscribers. Use zero to discard the feature", 'pcpp_ml') .'</span></td>
	</tr>';
}


// existing users association
function pcpp_eua_field($field_id, $field, $value, $all_vals) {
	include_once(PCPP_DIR .'/functions.php');
	
	global $pc_users, $pcpp_subscr;
	?>
	<table class="widefat lcwp_settings_table pc_settings_block">
      <tbody>
        <tr>
          <td class="lcwp_sf_label"><?php _e('Which plan to associate?', 'pcpp_ml') ?></td>
          <td class="lcwp_sf_field">
             <select name="pcpp_no_plan_set" id="pcpp_no_plan_set" class="lcwp_sf_chosen" data-placeholder="<?php _e('Select plan', 'pcpp_ml') ?> .." autocomplete="off" style="width: 100%;">
             <?php
             foreach($pcpp_subscr->get_plans(false) as $plan_id => $plan_name) {
                  echo '<option value="'.$plan_id.'">'.$plan_name . pcpp_dd_plan_details($plan_id) .'</option>';   
             }
             ?>
             </select>
          </td>
          <td <?php if((int)$all_vals['pcpp_trial_duration']) {echo 'rowspan="2"';} ?>>
              <input type="button" value=" <?php _e('Apply', 'pcpp_ml') ?> " class="button-secondary" id="pcpp_no_plan_set_btn" style="margin-left: 40px; min-height: 33px; padding: 0 30px;" />
              <span style="left: 17px; position: relative; top: 5px;"></span>
          </td>
        </tr>
        
        <?php if($all_vals['pcpp_trial_duration']) : ?>
        <tr>
          <td class="lcwp_sf_label">
              <?php _e('Apply trial period?', 'pcpp_ml') ?> (<?php echo $all_vals['pcpp_trial_duration'].' '.pcpp_sing_plur_switch($all_vals['pcpp_trial_type'], $all_vals['pcpp_trial_duration']); ?>)
          </td>
          <td class="lcwp_sf_field">
              <input type="checkbox" name="pcpp_apply_trial"  id="pcpp_apply_trial" value="1" autocomplete="off" class="lcwp_sf_check" />
          </td>
        </tr>
        <?php
        endif;
        ?>
        
      </tbody>
    </table>	
    <?php
}





// PCPP OPTIONS - fields
function pcpp_settings($structure) {
	include_once(PC_DIR .'/functions.php');
	include_once(PC_DIR .'/classes/pc_form_framework.php');
	include_once(PCPP_DIR .'/functions.php');
	
	global $pc_users, $pcpp_subscr;
	$f_fw = new pc_form;
	
	$avail_ecomm = pcpp_avail_ecomm();
	$pages = get_pages(); 
	
	// available plans
	$form_plans = array();
	foreach($pcpp_subscr->get_plans() as $plan_id => $name) {
		$form_plans[$plan_id] = $name . pcpp_dd_plan_details($plan_id);	
	}
	
	
	// custom fields for billing association
	$cust_fields = array('' => __('Do not associate fields', 'pcpp_ml'));
	foreach($f_fw->fields as $f_index => $f_data) {
		if(!in_array($f_index, array_merge($pc_users->fixed_fields, array('pc_disclaimer', 'pcpp_plan')) )) {
			$cust_fields[$f_index] = $f_data['label'];	
		}
	}
	
	// message if trying to enable but have no plans
	if(isset($GLOBALS['pcpp_no_implement_warn'])) {
		echo '<div class="error"><p>Premium Plans add-on - '. __('integration disabled. No plans found', 'pcpp_ml') .'</p></div>';	
	}
	
	
	$opts = array(
		'pcpp_main_settings' => array(
			'sect_name'	=>  __('Main settings', 'pcpp_ml'),
			'fields' 	=> array(
	
				'pcpp_ecomm_to_use' => array(
					'label' => __('Which e-commerce system to use?', 'pcpp_ml'),
					'type'	=> 'select',
					'val' 	=> $avail_ecomm,
					'hide'	=> (count($avail_ecomm) < 2) ? true : false,
					'note'	=> __('Choose which e-commerce plugin to use to manage purchases', 'pcpp_ml'), 
				), 
				'pcpp_default_plan' => array(
					'label' => __('Default plan', 'pcpp_ml'),
					'type'	=> 'select',
					'val' 	=> $form_plans,
					'fullwidth' => true,
					'note'	=> __('Choose which plan will be suggested and selected by default in registration forms', 'pcpp_ml'), 
				),
				'pcpp_enabled' => array(
					'label' => __('Enable add-on integration?', 'pcpp_ml'),
					'type'	=> 'checkbox',
					'note'	=> __('If checked, enables frontend integration, requiring a subscription plan selection', 'pcpp_ml'),
				),
				'pcpp_use_coupon' => array(
					'label' => __('Enable coupons integration?', 'pcpp_ml'),
					'type'	=> 'checkbox',
					'note'	=> __('If checked, allows users to enter discount coupons on registration', 'pcpp_ml'),
				),
				'pcpp_trial_preriod_field' => array(
					'type'		=> 'custom',
					'callback'	=> 'pcpp_trial_preriod_field',
					'validation'=> array(
						array('index' => 'pcpp_trial_duration', 'label' => __('Trial period', 'pcpp_ml'), 'required' => true, 'type' => 'int'),
						array('index' => 'pcpp_trial_type', 'label' => 'Trial period type'),
					)
				), 
				'pcpp_trial_txt' => array(
					'label' => __('Trial period - custom text', 'pcpp_ml'),
					'type'	=> 'text',
					'fullwidth' => true,
					'note'	=> __('By default is "&lt;strong&gt;X PERIOD-TYPE free trial!&lt;/strong&gt;"', 'pcpp_ml'),
				),
			),
		), 
	);
		
		
	$opts['pcpp_checkout'] = array(
		'sect_name'	=>  __('Checkout integration', 'pcpp_ml'),
		'fields' 	=> array(

			'pcpp_order_ok_page' => array(
				'label' => __('Successful order redirect', 'pcpp_ml'),
				'type'	=> 'select',
				'val' 	=> array('0' => '['. __('Use default page', 'pcpp_ml') .']') + pc_get_pages(),
				'note'	=> __("Choose where to redirect users after successful checkout", 'pcpp_ml') .'. <br/><strong style="color: #d54e21;">'. __('Using custom page, be sure it is brand new. By default will redirect to homepage', 'pcpp_ml') .'</strong>', 
			), 
			'pcpp_order_del_page' => array(
				'label' => __('Cancelled order redirect', 'pcpp_ml'),
				'type'	=> 'select',
				'val' 	=> pc_get_pages(),
				'note'	=> __("Landing page used to delete user orders", 'pcpp_ml') .'. <br/><strong style="color: #d54e21;">'. __('Use a new page, by default will redirect to homepage', 'pcpp_ml') .'</strong>', 
			), 
			'pcpp_order_renew_page' => array(
				'label' => __('Renew order page', 'pcpp_ml'),
				'type'	=> 'select',
				'val' 	=> array('0' => '['. __('Avoid plan change', 'pcpp_ml') .']') + pc_get_pages(),
				'note'	=> __("Page used to let users change their subscription plan. By default avoid changes, simply creating a new order. To show plan's selection form use <strong>[pcpp-change-plan]</strong> shortcode", 'pcpp_ml') .'. <br/><strong style="color: #d54e21;">'. __('Using custom page, be sure it is brand new. By default will redirect to homepage', 'pcpp_ml') .'</strong>', 
			),
		),
	);
	
	
	if(!empty($cust_fields)) {
		$opts['billing_fields'] = array(
			'sect_name'	=>  __('Billing fields association', 'pcpp_ml'),
			'fields' 	=> array(
	
				'pcpp_bill_company_f' => array(
					'label' => __('Company field', 'pcpp_ml'),
					'type'	=> 'select',
					'val' 	=> $cust_fields,
					'note'	=> __("Choose which form field to associate for company", 'pcpp_ml'),
				), 
				'pcpp_bill_address_f' => array(
					'label' => __('Address field', 'pcpp_ml'),
					'type'	=> 'select',
					'val' 	=> $cust_fields,
					'note'	=> __("Choose which form field to associate for address", 'pcpp_ml'),
				), 
				'pcpp_bill_city_f' => array(
					'label' => __('City field', 'pcpp_ml'),
					'type'	=> 'select',
					'val' 	=> $cust_fields,
					'note'	=> __("Choose which form field to associate for city", 'pcpp_ml'),
				), 
				'pcpp_bill_postcode_f' => array(
					'label' => __('Postcode field', 'pcpp_ml'),
					'type'	=> 'select',
					'val' 	=> $cust_fields,
					'note'	=> __("Choose which form field to associate for postcode", 'pcpp_ml'),
				),
				'pcpp_bill_state_f' => array(
					'label' => __('State field', 'pcpp_ml'),
					'type'	=> 'select',
					'val' 	=> $cust_fields,
					'note'	=> __("Choose which form field to associate for state", 'pcpp_ml'),
				),
				'pcpp_bill_country_f' => array(
					'label' => __('Country field', 'pcpp_ml'),
					'type'	=> 'select',
					'val' 	=> $cust_fields,
					'note'	=> __("Choose which form field to associate for country", 'pcpp_ml') .'.<br/><span style="color: #d54e21;">'. __("Chosen field will be transformed into a dropdown with country values", 'pcpp_ml') .'</span>',
				),
			),
		);
	}
	
	
	$opts['pcpp_messages'] = array(
		'sect_name'	=>  __('Messages', 'pcpp_ml'),
		'fields' 	=> array(
			
			'pcpp_registr_mex' => array(
				'label' 	=> __('Default message for unlogged users', 'pcpp_ml'),
				'type'		=> 'text',
				'maxlen'	=> 250,
				'fullwidth'	=> true,
				'note'		=> __('By default is "Successful registration! Now you will be moved to checkout page"', 'pcpp_ml').' <strong>('. __('Only if there is no trial period', 'pcpp_ml') .')</strong>',
			),
			'pcpp_unpaid_mex' => array(
				'label' 	=> __('Unpaid subscriptions login message (checkout link is appended)', 'pcpp_ml'),
				'type'		=> 'text',
				'maxlen'	=> 250,
				'fullwidth'	=> true,
				'note'		=> __('By default is "Hello, you have an unpaid subscription"', 'pcpp_ml'),
			),
			'pcpp_exp_trial_mex' => array(
				'label' 	=> __('Expired trial period login message (checkout link is appended)', 'pcpp_ml'),
				'type'		=> 'text',
				'maxlen'	=> 250,
				'fullwidth'	=> true,
				'note'		=> __('By default is "Hello, your trial period ended"', 'pcpp_ml'),
			),
			'pcpp_expired_mex' => array(
				'label' 	=> __('Expired subscriptions login message (link to renew is appended)', 'pcpp_ml'),
				'type'		=> 'text',
				'maxlen'	=> 250,
				'fullwidth'	=> true,
				'note'		=> __('By default is "Hello, your subscription has expired"', 'pcpp_ml'),
			),
		),
	);
	
	
	$opts['pcpp_extra'] = array(
		'sect_name'	=>  __('Extra', 'pcpp_ml'),
		'fields' 	=> array(
			
			'pcpp_enable_pending_after_checkout' => array(
				'label' => __('Enable pending user after checkout?', 'pc_ml'),
				'type'	=> 'checkbox',
				'note'	=> __("If checked, automatically enables pending user after successful checkout", 'pc_ml'),
			), 
			'pcpp_del_orders_on_user_del' => array(
				'label' => __('Delete orders on user deletion?', 'pc_ml'),
				'type'	=> 'checkbox',
				'note'	=> __("If checked, will remove orders on user deletion", 'pc_ml'),
			), 
			'pcpp_reg_form_btn_text' => array(
				'label' 	=> __('Custom registration form button text', 'pcpp_ml'),
				'type'		=> 'text',
				'maxlen'	=> 50,
				'fullwidth'	=> true,
				'note'		=> __('Set a custom value for registration form button, replacing "submit"', 'pcpp_ml'),
			),
		),
	);
	
	
	$opts['pcpp_eua'] = array(
		'sect_name'	=>  __('Existing users association', 'pcpp_ml'),
		'fields' 	=> array(
			
			'pcpp_eua_field' => array(
				'type'		=> 'custom',
				'callback'	=> 'pcpp_eua_field',
			), 
		),
	);
	

	$structure['pcpp_setting'] = $opts;
	return $structure;
}
add_filter('pc_settings_structure', 'pcpp_settings');




// PCPP OPTIONS - extra codes
function pcpp_settings_js() {
	?>
    <script type="text/javascript">
	jQuery(document).ready(function(e) {
        var pcpp_is_acting = false;
		
		jQuery('#pcpp_no_plan_set_btn').click(function() {
			if(pcpp_is_acting) {return false;}
			
			if(confirm("<?php _e("This will be applied to EVERY user without an associated plan. Confirm?", 'pcpp_ml') ?>")) {
				pcpp_is_acting = true;
				var $subj = jQuery(this).parent();
				$subj.find('span').html('<div class="pc_loading" style="margin-bottom: -7px;"></div>');

				var data = {
					action: 'pcpp_bulk_no_plan_assoc',
					plan_id: jQuery('#pcpp_no_plan_set').val(),
					use_trial: (jQuery('#pcpp_apply_trial').size() && jQuery('#pcpp_apply_trial').is(':checked')) ? 1 : 0,
					pcpp_nonce: '<?php echo wp_create_nonce('lcwp_ajax') ?>'
				};
				jQuery.post(ajaxurl, data, function(response) {
					var resp = jQuery.trim(response);
					
					if(resp != 'success') {
						alert(response);
						$subj.find('span').empty();
					} else {
						$subj.find('span').html("<?php _e('Plan associated successfully', 'pcpp_ml') ?>!");
					}
					
					pcpp_is_acting = false;
				});	
			}
		});
    });
	</script>
    <?php	
}
add_action('pc_settings_extra_code', 'pcpp_settings_js');





// trick to avoid add-on implementation if no products are set up 
function pcpp_settings_save($fdata) {
	
	if((!isset($fdata['pcpp_default_plan']) || empty($fdata['pcpp_default_plan'])) && isset($fdata['pcpp_enabled']) && $fdata['pcpp_enabled']) {
		$fdata['pcpp_enabled'] = false;
		$GLOBALS['pcpp_no_implement_warn'] = true;	
	}
	
	return $fdata;
}
add_filter('pc_before_save_settings', 'pcpp_settings_save');
