<?php
////////// SHORCODES LIST


// [pcpp-change-plan] 
//// form to allow plan changing and order renewal

function pcpp_change_plan_sc($atts, $content = null) {
	include_once(PC_DIR .'/classes/pc_form_framework.php');
	include_once(PCPP_DIR .'/functions.php');
	
	global $pc_users, $pc_meta, $pcpp_subscr;
	
	if(!$GLOBALS['pcpp_enabled']) {return false;}
	if(!isset($_REQUEST['uid']) || !isset($_REQUEST['uid'])) {return __('Missing parameters ..', 'pcpp_ml');}
	
	$user_id = (int)$_REQUEST['uid'];
	$order_id = $_REQUEST['oid'];
	
	// check parameters validity
	if(md5($pc_meta->get_meta($user_id, 'pcpp_active_order')) != $order_id) {
		return __("Order ID doesn't match", 'pcpp_ml');
	}
	
	$subscr_status = $pc_meta->get_meta($user_id, 'pcpp_subscr_status');
	if(empty($subscr_status) || $subscr_status != 'expired') {return __("Your subscription isn't expired", 'pcpp_ml');}


	// form code 
	$form = '
	<form class="pc_custom_form pcpp_change_plan_form pc_fluid_form">
		<input type="hidden" name="pcpp_uid" value="'. $user_id .'" />';
		
		$GLOBALS['pcpp_renewal_form'] = true;
		
		$f_fw = new pc_form;
		$form .= $f_fw->form_code(
			array(
				'include' => array('pcpp_plan'), 
				'require' => array()
			), 
			$custom_fields = false, $user_id
		);
		
		unset($GLOBALS['pcpp_renewal_form']);
	
		$form .= '
		<div class="pc_form_response pcpp_form_message"></div>
	
		<input type="button" class="pcpp_change_plan_btn" value="'. __('Renew Subscription', 'pcpp_ml') .'" />
	</form>';
	
	return str_replace(array("\r", "\n", "\t", "\v"), '', $form);
}
add_shortcode('pcpp-change-plan', 'pcpp_change_plan_sc');






// [pcpp-user-plan] 
//// retrieve current user's plan name

function pcpp_user_plan($atts, $content = null) {
	$user_plan = pc_user_logged(array('pcpp_plan'));
	return (empty($user_plan)) ? false : get_the_title($user_plan); 
}
add_shortcode('pcpp-user-plan', 'pcpp_user_plan');







// [pcpp-subscr-expir] 
//// retrieve current user subscription's expiration date shown as date or countdown

function pcpp_subscr_expir($atts, $content = null) {
	
	extract( shortcode_atts( array(
		'type' 			=> 'date',
		'date_format' 	=> get_option('date_format', 'j F Y'),
	), $atts ) );

	$user_data = pc_user_logged(array('pcpp_plan', 'pcpp_subscr_end'));

	// be sure current user has got a valid subscription
	if(empty($user_data['pcpp_plan'])) {
		return false;	
	}
	
	// unlimited plan?
	if($user_data['pcpp_subscr_end'] == 'unlimited') {
		return __('no expiration', 'pcpp_ml');
	}


	// date or countdown
	if($type == 'date') {
		$txt = date_i18n($date_format, $user_data['pcpp_subscr_end']);
	}
	else {	
		// countdown calculation
		$timestamp = (int)$user_data['pcpp_subscr_end'] - current_time('timestamp');
	
		//create multi-array with seconds and define values
		$values = array(
			12*30*24*60*60  =>  'year',
			30*24*60*60     =>  'month',
			24*60*60        =>  'day',
			60*60           =>  'hour',
			60              =>  'minute',
		);
	
		//loop over the array
		foreach ($values as $secs => $point){
			$res = floor($timestamp / $secs);
			
			// translatable strings
			switch($point) {
				case 'year' : $txt = ($res > 1) ? __('years', 'pc_ml') : __('year', 'pc_ml'); break; 
				case 'month': $txt = ($res > 1) ? __('months', 'pc_ml') : __('month', 'pc_ml'); break;
				case 'day'  : $txt = ($res > 1) ? __('days', 'pc_ml') : __('day', 'pc_ml'); break;	
				case 'hour' : $txt = ($res > 1) ? __('hours', 'pc_ml') : __('hour', 'pc_ml'); break;	
				case'minute': $txt = ($res > 1) ? __('minutes', 'pc_ml') : __('minute', 'pc_ml'); break;	
			}
			
			$txt = $res. ' ' .$txt;
			if($res >= 1) {
				break;	
			}
		}	
	}
	
	return '<time title="'. date_i18n(get_option('date_format').' - '. get_option('time_format'), $user_data['pcpp_subscr_end']) .'">'. $txt .'</time>'; 
}
add_shortcode('pcpp-subscr-expir', 'pcpp_subscr_expir');

