<?php
// PRIVATECONTENT INTEGRATIONS - SHOTRCODES


add_filter('pc_tinymce_tabs', 'pcpp_tinymce_tabs');

function pcpp_tinymce_tabs($tabs) {
	
	$contents = '
	<li class="lcwp_scw_field pc_scw_field">
		<label>'. __('What to display', 'pcpp_ml') .'</label>

		<select name="pcpp_wtd" class="lcweb-chosen f_type" data-placeholder="'. __('Select an option', 'pcpp_ml') .' .." autocomplete="off">
			<option value="plan_name">'. __("Plan's name", 'pcpp_ml') .'</option>
			<option value="plan_expir_date">'. __("Plan's expiration date", 'pcpp_ml') .'</option>
			<option value="plan_expir_cdown">'. __("Plan's expiration countdown", 'pcpp_ml') .'</option>
		</select>
	</li>
	<li class="lcwp_scw_field pc_scw_field pcpp_date_format_f" style="display: none;">
		<label>'. __('Date format', 'pcpp_ml') .'</label>

		<input type="text" name="pcpp_plan_date_format" placeholder="'. get_option('date_format') .'" autocomplete="off" />
		
		<p>'. __('Please refer to <a href="http://php.net/manual/en/function.date.php" target="_blank">PHP date guide</a> to know what to insert. <br/>Leave blank to use the default website date format.', 'pcpp_ml') .'</p>
	</li>
	<li class="lcwp_scw_field pc_scw_field">
		<input type="button" id="pcpp-subscr-data-submit" class="button-primary" value="'. __('Insert', 'pcpp_ml') .'" name="submit" />
	</li>';
	
	
	$tabs['pcpp_subscr_data'] = array(
		'name' 		=> 'PCPP - '. __("Subscription Details", 'pcpp_ml'),
		'contents'	=> '<ul>'. $contents .'</ul>'
	);

	$GLOBALS['pcpp_print_tinymce_js'] = true;
	return $tabs;
}




// add javascript code in footer
add_action('admin_footer', 'pcpp_tinymce_js');
function pcpp_tinymce_js() {
	if(!isset($GLOBALS['pcpp_print_tinymce_js']));	
	
	?>
	<script type="text/javascript">
	jQuery(document).ready(function(e) {
		
		// date format field toggle
		jQuery(document).on('change', '.pc_sc_wizard_lb [name=pcpp_wtd]', function() {
			
			(jQuery(this).val() == 'plan_expir_date') ?	jQuery('.pc_sc_wizard_lb .pcpp_date_format_f').show() : jQuery('.pc_sc_wizard_lb .pcpp_date_format_f').hide();
		});
		
		
		// insert
		jQuery(document).on('click', '.pc_sc_wizard_lb #pcpp-subscr-data-submit', function() {
			var wts = jQuery('.pc_sc_wizard_lb [name=pcpp_wtd]').val();
			var sc = '';
		
			// plan's name
			if(wts == 'plan_name') {
				sc = '[pcpp-user-plan]';	
			}
		
			// plan's expiration date
			else if(wts == 'plan_expir_date') {
				var date_format = (jQuery.trim( jQuery('.pc_sc_wizard_lb [name=pcpp_plan_date_format]').val())) ? 'date_format="'+ jQuery('.pc_sc_wizard_lb [name=pcpp_plan_date_format]').val() +'"' : '';
				sc = '[pcpp-subscr-expir '+ date_format +']';
			}
			
			// plan's expiration countdown
			else if(wts == 'plan_expir_cdown') {
				sc = '[pcpp-subscr-expir type="cdown"]';	
			}
		
		
			tinyMCE.activeEditor.execCommand("mceInsertContent", 0, sc);
			jQuery.magnificPopup.close();	
		});
		
	});
	</script>
    <?php
}

